## API Report File for "@genesislcap/foundation-fdc3"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

/// <reference types="node" />

import type { AppIdentifier } from '@finos/fdc3';
import type { AppIntent } from '@finos/fdc3';
import type { Channel } from '@finos/fdc3';
import type { Context } from '@finos/fdc3';
import type { ContextHandler } from '@finos/fdc3';
import type { ContextMetadata } from '@finos/fdc3';
import { Controller } from '@microsoft/fast-element';
import { DOMContainer } from '@genesislcap/foundation-utils';
import { FoundationElement } from '@genesislcap/web-core';
import { FoundationElementRegistry } from '@microsoft/fast-foundation';
import { FoundationLayoutContainer } from '@genesislcap/foundation-utils';
import type { IntentHandler } from '@finos/fdc3';
import type { IntentResolution } from '@finos/fdc3';
import type { Intents } from '@finos/fdc3';
import { InterfaceSymbol } from '@microsoft/fast-foundation';
import { IOConnectDesktop } from '@interopio/desktop';
import { LayoutCacheContainer } from '@genesislcap/foundation-utils';
import type { Listener } from '@finos/fdc3';
import { Logger } from '@genesislcap/foundation-logger';
import { NotificationDataRow } from '@genesislcap/foundation-notifications';
import { NotificationListener } from '@genesislcap/foundation-ui';
import { Observable } from 'rxjs';
import { OverrideFoundationElementDefinition } from '@microsoft/fast-foundation';
import type { PrivateChannel } from '@finos/fdc3';
import type { StandardIntent } from '@finos/fdc3';
import { ViewTemplate } from '@microsoft/fast-element';

// @alpha
export interface AppChannelListenerConfig extends SystemChannelListenerConfig {
    // (undocumented)
    channelName: string;
}

export { AppIdentifier }

export { AppIntent }

export { Channel }

export { Context }

export { ContextHandler }

export { ContextMetadata }

// Warning: (ae-internal-missing-underscore) The name "DefaultFDC3" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal
export class DefaultFDC3 implements FDC3 {
    constructor();
    // (undocumented)
    addChannelListener(channelName: string, channelType: string, callback: (any: any) => void): Promise<Channel>;
    // (undocumented)
    addIntentListeners(listeners: Map<FDC3Intents, FDC3ContextHandler>): void;
    // (undocumented)
    addSystemChannelListener(channelType: string, callback: (any: any) => void): Promise<void>;
    // (undocumented)
    broadcastOnChannel(channelName: string, type: string, payload: any): Promise<void>;
    // (undocumented)
    broadcastOnChannelEventHandler(channelName: string, type: string): Promise<(e: any) => Promise<void>>;
    // (undocumented)
    broadcastOnCurrentChannel(payload: any, type?: string): Promise<void>;
    // (undocumented)
    currentChannel$: Observable<Channel>;
    // (undocumented)
    findIntent(intent: FDC3Intents, context?: FDC3Context): Promise<FDC3AppIntent>;
    // (undocumented)
    findIntentsByContext(context: FDC3Context): Promise<FDC3AppIntent[]>;
    // (undocumented)
    getCurrentChannel(): Promise<Channel>;
    // (undocumented)
    getOrCreateChannel(channelId: string): Promise<FDC3Channel>;
    // (undocumented)
    handleChannelCurrentContext(channel: Channel | FDC3Channel, contextType: string, listenerCallback: (FDC3Context: any) => any): Promise<void>;
    // (undocumented)
    isInteropFdc3: () => boolean;
    // (undocumented)
    isReady$: Observable<true>;
    // (undocumented)
    isReady: boolean;
    // (undocumented)
    joinChannel(channelId: string): Promise<void>;
    // (undocumented)
    raiseIntent(context: FDC3Context, intent?: FDC3Intents): Promise<FDC3IntentResolution>;
    // (undocumented)
    raiseIntentForContext(context: FDC3Context): Promise<FDC3IntentResolution>;
}

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "FDC3" because one of its declarations is marked as @internal
//
// @public
export interface FDC3 {
    addChannelListener(channelName: string, channelType: string, callback: (any: any) => void): Promise<Channel>;
    addIntentListeners(listeners: Map<FDC3Intents, FDC3ContextHandler>): void;
    addSystemChannelListener(channelType: string, callback: (any: any) => void): Promise<void>;
    broadcastOnChannel(channelName: string, type: string, payload: any): Promise<void>;
    broadcastOnChannelEventHandler(channelName: string, type: string): Promise<(e: any) => Promise<void>>;
    broadcastOnCurrentChannel(payload: any, type?: string): Promise<void>;
    currentChannel$: Observable<FDC3Channel>;
    findIntent(intent: FDC3Intents, context?: FDC3Context): Promise<FDC3AppIntent>;
    findIntentsByContext(context: FDC3Context): Promise<FDC3AppIntent[]>;
    getCurrentChannel(): Promise<Channel>;
    getOrCreateChannel(channelId: string): Promise<FDC3Channel>;
    handleChannelCurrentContext(channel: Channel | FDC3Channel, contextType: string, listenerCallback: (FDC3Context: any) => any): Promise<void>;
    isInteropFdc3: () => boolean;
    isReady$: Observable<true>;
    isReady: boolean;
    joinChannel(channelId: string): Promise<void>;
    raiseIntent(context: FDC3Context, intent?: FDC3Intents): Promise<FDC3IntentResolution>;
    raiseIntentForContext(context: FDC3Context): Promise<FDC3IntentResolution>;
}

// @internal
export const FDC3: InterfaceSymbol<FDC3>;

// @public @deprecated (undocumented)
export interface FDC3AppIntent extends AppIntent {
}

// @public @deprecated (undocumented)
export interface FDC3Channel extends Channel {
}

// Warning: (ae-forgotten-export) The symbol "Fdc3ChannelEvent_base" needs to be exported by the entry point index.d.ts
// Warning: (ae-internal-missing-underscore) The name "Fdc3ChannelEvent" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal
export class Fdc3ChannelEvent extends Fdc3ChannelEvent_base {
    // (undocumented)
    channelName: string;
    // (undocumented)
    channelType: string;
    // (undocumented)
    connectedCallback(): void;
    // (undocumented)
    deepClone(): Node;
    // (undocumented)
    disconnectedCallback(): void;
    // (undocumented)
    eventName: string;
    // (undocumented)
    fdc3: FDC3;
    // (undocumented)
    mappingFunction: (any: any) => any;
}

// @public @deprecated (undocumented)
export interface FDC3Context extends Context {
}

// @public @deprecated (undocumented)
export type FDC3ContextHandler = ContextHandler;

// @alpha
export class Fdc3ContextListener extends Fdc3SystemChannelListener {
    // (undocumented)
    protected addChannelListeners(): void;
    // (undocumented)
    config: AppChannelListenerConfig[];
}

// Warning: (ae-forgotten-export) The symbol "Fdc3IntentListener_base" needs to be exported by the entry point index.d.ts
//
// @alpha
export class Fdc3IntentListener extends Fdc3IntentListener_base {
    // (undocumented)
    connectedCallback(): void;
    // (undocumented)
    deepClone(): Node;
    // (undocumented)
    fdc3: FDC3;
    // (undocumented)
    intentConfig: IntentConfig[];
}

// @public @deprecated (undocumented)
export interface FDC3IntentResolution extends IntentResolution {
}

// @public @deprecated (undocumented)
export type FDC3Intents = Intents;

// Warning: (ae-forgotten-export) The symbol "Fdc3RaiseIntent_base" needs to be exported by the entry point index.d.ts
//
// @alpha
export class Fdc3RaiseIntent extends Fdc3RaiseIntent_base {
    // (undocumented)
    connectedCallback(): void;
    // (undocumented)
    deepClone(): Node;
    // (undocumented)
    disconnectedCallback(): void;
    // (undocumented)
    eventName: string;
    // (undocumented)
    fdc3: FDC3;
    // (undocumented)
    intentName: string;
    // (undocumented)
    intentType: string;
    // (undocumented)
    mappingFunction: (any: any) => any;
}

// Warning: (ae-forgotten-export) The symbol "Fdc3SystemChannelListener_base" needs to be exported by the entry point index.d.ts
//
// @alpha
export class Fdc3SystemChannelListener extends Fdc3SystemChannelListener_base {
    // (undocumented)
    protected addChannelListeners(): void;
    // (undocumented)
    config: SystemChannelListenerConfig[];
    // (undocumented)
    connectedCallback(): void;
    // (undocumented)
    deepClone(): Node;
    // (undocumented)
    disconnectedCallback(): void;
    // (undocumented)
    fdc3: FDC3;
}

// @alpha
export interface IntentConfig {
    // (undocumented)
    callback: (FDC3Context: any) => void;
    // (undocumented)
    intent: string;
}

export { IntentHandler }

export { IntentResolution }

export { Intents }

// @public
export const interopFoundationNotificationListener: (overrideDefinition?: OverrideFoundationElementDefinition<    {
baseName: string;
template: ViewTemplate<NotificationListener, any>;
shadowOptions: ShadowRootInit;
}>) => FoundationElementRegistry<    {
baseName: string;
template: ViewTemplate<NotificationListener, any>;
shadowOptions: ShadowRootInit;
}, typeof InteropNotificationsListener>;

// @public (undocumented)
export class InteropNotificationsListener extends NotificationListener {
    // (undocumented)
    iOConnectNotificationOptions: IOConnectDesktop.Notifications.IOConnectNotificationOptions;
    // (undocumented)
    protected showNotificationToast(row: NotificationDataRow): void;
}

export { Listener }

// @public
export const logger: Logger;

export { PrivateChannel }

export { StandardIntent }

// @alpha
export interface SystemChannelListenerConfig {
    // (undocumented)
    callback: (any: any) => void;
    // (undocumented)
    channelType: string;
}

// (No @packageDocumentation comment for this package)

```
